package org.nakedobjects.applib.util;

import junit.framework.TestCase;

public class ReasonStringTest extends TestCase {
    private ReasonBuffer reason;

    public void testNoReasonReturnsNull() throws Exception {
        assertEquals(null, reason.getReason());
    }
    
    public void testAReasonReturnsString() throws Exception {
        reason.append("reason 1");
        assertEquals("reason 1", reason.getReason());
    }

    public void testConditionalAppendWithTrue() {
        reason.appendOnCondition(true, "reason 1");
        assertEquals("reason 1", reason.getReason());
    }

    public void testConditionalAppendWithFalse() {
        reason.appendOnCondition(false, "reason 1");
        assertEquals(null, reason.getReason());
    }
    
    public void testAppendTwoReasons() {
        reason.append("reason 1");
        reason.append("reason 2");
          assertEquals("reason 1; reason 2", reason.getReason());

    }

    protected void setUp() {
        reason = new ReasonBuffer();
    }
}


// Copyright (c) Naked Objects Group Ltd.
