package org.nakedobjects.applib.value;

import junit.framework.TestCase;

public class TimeStampTest extends TestCase {

    private TimeStamp timeStamp;

    protected void setUp() throws Exception {
        TestClock.initialize();
        timeStamp = new TimeStamp();
    }

    public void testCreatesToClocksTime() {
        assertEquals(1061155825000L, timeStamp.longValue());
    }
    
    public void testEqualsTo() {
        TimeStamp timeStamp2 = new TimeStamp();
        assertFalse(timeStamp2 == timeStamp);
        
        assertTrue(timeStamp.isEqualTo(timeStamp2));
        assertTrue(timeStamp2.isEqualTo(timeStamp));
    }
    
    public void testLessThan() {
        TimeStamp timeStamp2 = new TimeStamp(1061155825050L);
        
        assertTrue(timeStamp.isLessThan(timeStamp2));
        assertFalse(timeStamp2.isLessThan(timeStamp));
    }
    
}



// Copyright (c) Naked Objects Group Ltd.
